{
  edition = 201909;

  description = "Genode packages";

  inputs = {
    nixpkgs.uri = "git+file:///home/repo/nixpkgs?ref=genode";
    dhall-haskell.uri =
      "git+https://github.com/dhall-lang/dhall-haskell?ref=flake";
  };

  outputs = { self, nixpkgs, dhall-haskell, genode-depot }:
    let
      systems = [ "x86_64-genode" ];

      forAllSystems = f: nixpkgs.lib.genAttrs systems (system: f system);

    in {

      lib = import ./lib {
        genodepkgs = self;
        inherit nixpkgs dhall-haskell genode-depot;
      };

      packages = forAllSystems (system:
        import ./packages.nix {
          inherit system nixpkgs;
          depot = builtins.getAttr system genode-depot.packages;
        });

      checks = forAllSystems (system:
        import ./tests {
          inherit self nixpkgs dhall-haskell genode-depot;
          genodepkgs = builtins.getAttr system self.packages;
        });

    };
}
