# SPDX-FileCopyrightText: Emery Hemingway
#
# SPDX-License-Identifier: LicenseRef-Hippocratic-1.1

{ system, nixpkgs, depot }:

let
  toolchainOverlay = import ./toolchain-overlay;
  # Overlay of toolchain patches

  super = builtins.getAttr system nixpkgs.legacyPackages;

  inherit (super) callPackage;

  genode = (callPackage ./upstream { } // {
    nic_bus = callPackage ./pkgs/nic_bus { };
  });
  dhallPackages = super.dhallPackages // (callPackage ./dhall { });
in rec {
  inherit (super) stdenv;
  genode-base = genode.base;
  genode-base-linux = genode.base-linux;
  genode-base-nova = genode.base-nova;
  genode-os = genode.os;
  libc = callPackage ./pkgs/libc { inherit depot; };
  stdcxx = callPackage ./pkgs/stdcxx { };

  dhallGenode = dhallPackages.genode;
  dhallPrelude = dhallPackages.prelude;
  nova = callPackage ./NOVA { };
  solo5 = callPackage ./pkgs/solo5 { inherit genode-base genode-os; };
}
